import java.util.*;
import javax.microedition.lcdui.*;
public class Main extends Canvas
{
    Midlet ml;
    int[] x = new int[4];
    int[] y = new int[4];
    double[] dd = new double[2];
    int w, h, dt;
    String[] s = new String[6];
    Font f = Font.getFont(0, 0, 8);
    boolean current;
    Random r;
    public Main(Midlet ml)
    {
        this.ml = ml;
        setFullScreenMode(true);
        r = new Random();
        rand();
        w = getWidth();
        h = getHeight();
    }
    public void paint(Graphics g)
    {
        g.setColor(0);
        g.fillRect(0, 0, w, h);
        tinh();
        g.setColor(0x0000ff);
        g.fillTriangle(x[1], y[1], x[2], y[2], x[3], y[3]);
        g.setColor(0xff0000);
        g.setFont(f);
        dline(g);
        if (current)
        {
            for (int i = 0; i < s.length; i++)
            {
                g.drawString(s[i], 0, i * (f.getHeight() + 2), 0);
            }
        }
        repaint();
        try
        {
            Thread.sleep(11);
        }
        catch(Exception e)
        {
        }
    }
    void dline(Graphics g)
    {
        g.drawString("About", 0, h, Graphics.BOTTOM | Graphics.LEFT);
        g.drawLine(x[1], y[1], x[2], y[2]);
        g.drawLine(x[1], y[1], x[3], y[3]);
        g.drawLine(x[3], y[3], x[3], y[3]);
        g.drawLine(x[0], y[0], x[1], y[1]);
        g.drawLine(x[0], y[0], x[2], y[2]);
        g.drawLine(x[0], y[0], x[3], y[3]);
        g.drawString("A", x[1], y[1], 0);
        g.drawString("B", x[2], y[2], 0);
        g.drawString("C", x[3], y[3], 0);
        g.drawString("H", x[0], y[0], 0);
    }
    void rand()
    {
        for (int i = 1; i < x.length; i++)
        {
            x[i] = 30 + ran(w - 30);
            y[i] = 30 + ran(h - 30);
        }
        if ((x[1] == x[2] && y[1] == y[2]) || (x[1] == x[3] && y[1] == y[3]) || (x[2] == x[3] && y[2] == y[3]) || (x[1] == x[2] && x[1] == x[3]) || (y[1] == y[2] && y[1] == y[3]))
        {
            rand();
        }
    }
    int ran(int i)
    {
        int a = Math.abs(r.nextInt() % i);
        return a;
    }
    void tinh()
    {
        double d, dx, dy;
        d = (y[3] - y[2]) * (y[3] - y[2]) - (x[3] - x[2]) * (x[2] - x[3]);
        dx = (x[2] * y[3] - x[3] * y[2]) * (y[3] - y[2]) - (x[1] * x[3] - x[1] * x[2] + y[1] * y[3] - y[1] * y[2]) * (x[2] - x[3]);
        dy = (y[3] - y[2]) * (x[1] * x[3] - x[1] * x[2] + y[1] * y[3] - y[1] * y[2]) - (x[3] - x[2]) * (x[2] * y[3] - x[3] * y[2]);
        x[0] = (int)(dx / d);
        y[0] = (int)(dy / d);
        dd[0] = Math.sqrt((x[3] - x[2]) * (x[3] - x[2]) + (y[3] - y[2]) * (y[3] - y[2]));
        dd[1] = Math.sqrt((y[0] - y[1]) * (y[0] - y[1]) + (x[0] - x[1]) * (x[0] - x[1]));
        dt = (int)((dd[0] * dd[1]) / 2);
        s[0] = "A (" + x[1] + " ; " + y[1] + ")";
        s[1] = "B (" + x[2] + " ; " + y[2] + ")";
        s[2] = "C (" + x[3] + " ; " + y[3] + ")";
        s[3] = "Đáy BC: " + (int) dd[0];
        s[4] = "Đường cao AH: " + (int) dd[1];
        s[5] = "Diện tích: " + dt;
    }
    public void keyPressed(int k)
    {
        if (k == -5 || k == KEY_NUM5)
        {
            rand();
        }
        if (k == -6) current = !current;
    }
}